/*
	ܣʵ顣
	ģ飺HC-SR04෶Χ2cm to 450cm
	ʾxxx.xλcm
	㹫ʽ£
	s = v*t/2 = (340m/s)*t(s)/2 = (340um/us)*t(us)/2 = (0.34mm/us)*t(us)/2 = (0.034cm/us)*t(us)/2;;
	s(cm) = t(us)*0.017(cm/us).
	t is the received Echo high level time from the UltracsonicModule HC-SR04, 
	it messured by T0 timer, t=(12/11.0592)us*(TH0,TL0), initial (TH0,TL0)=0x00 00
	s(cm) =0.0184*(TH0,TL0),	(TH0,TL0)max = 24456 for s =450cm
	UltracsonicModule HC-SR04 VCC(+5V) connect to VCC; 
	Gnd connct to GND; 
	Trig connect to P3.3; 
	Echo connect to P3.2.
	෶
	ʾС255Σ0Ͳλcm
	ƣӿƼѧʵ20226
*/


#include <reg52.h>

//
sbit Echo = P3^2;	//Echo
sbit Trig = P3^3;	//Trig

#define LED_seg	P0			//8λܵĶλͨP0˿ 
#define LED_dig	P0

//ʾɶʱжϳԶɨ裩
unsigned char DispBuf[8];

//Сʾ·ܽŶ
sbit SS = P2^6;	   //ܶѡź
sbit CS = P2^7;	   //λѡź


bit Counter_overflag = 0;		//T0ʱ־
bit Echo_Over = 0; 					//ɱ־յزûյҪλһ
unsigned char cnt = 0;			//ÿμһ
unsigned int Range = 0;
unsigned long Echo_time = 0;		//T0ʱϲֵ

code unsigned char Tab[] =
	{//0123456789AbCdEFݣʾַм㣬确-Ϊ0x40
		0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,
		0x7F,0x6F,0x77,0x7C,0x39,0x5E,0x79,0x71
	};
//============================//
/*
EX0INTSVC()
ܣⲿж0жϷ
;ΪⶨʱжϸŲ׼ȷԣⲿжϴֹͣʱ
	    ⲿж0ȼڶʱжϣ̣Ŷʱж
*/
void EX0INTSVC() interrupt 0
{
	TR0 = 0;					//ֹͣʱ
	Echo_time = TH0 * 256 + TL0; 	//ȡʱ0ֵ
	TH0 = 0; 					//ʱ0ĴΪ´μ׼
	TL0 = 0;
	Echo_Over = 1; 		//ʾγɣ´εĲ
	EX0 = 0;					//رⲿжϣһж
}
//============================//
/*
T0INTSVC()
ܣʱT0жϷ
;෶Χʱ޷յز
	    ѾT0жϻöʱ־ж
*/
void T0INTSVC() interrupt 1 		 
{
	TR0 = 0;				//ֹͣʱ
	Counter_overflag = 1;			 //ж־δյز
	Echo_Over = 1;	//ʾγɣ´εĲ
	EX0 = 0;				//رⲿж
}
/*
T1INTSVC()
ܣʱT1жϷ
*/
void T1INTSVC() interrupt 3	//ʱ1жϺΪ3
{
	code unsigned char com[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};	//ʾλĶ˿ڿֽ
	static unsigned char n = 0;						//n: ɨʾλ,0-7

//================ܶʱɨʾ===============	
	TR1 = 0;
	TH1 = 0xFC;
	TL1 = 0x66;						//ԽFC660000ɨٶȣ۲⶯̬ɨ
	TR1 = 1;
	P0 = 0xFF;		//
	CS = 1;
	CS = 0;
	P0 = DispBuf[n];	//ɨʾ
	SS = 1;
	SS = 0;
	P0 = ~com[n];	//ʾ
	CS = 1;
	CS = 0;
	n++;					 	//ָһλɨʾ
	n &= 0x07;
//====================================================

}


/*
DispClear()
ܣܵʾ
*/
void DispClear()
{
	unsigned char i;
	for ( i=0; i<8; i++ )
	{
		DispBuf[i] = 0x00;	//iֵܵλںĳ۲0x00Թرʾ
	}
}

/*
Delay()
ܣʱ
˵
	ƵΪ11.0592MHz
	ʱ = 1ms * t
*/
void Delay(unsigned int t)
{
	unsigned int us_ct;
	for (;t > 0;t --)		//ִдCPUʱ
		for (us_ct = 113;us_ct > 0;us_ct --);	
}


/*
SysInit()
ܣϵͳʼ
*/
void SysInit()
{

	DispClear();	//ʼʾ
	TMOD = 0x11;	//öʱT0Ϊ16λʱʱT1Ϊ16λʱ
	EA = 0;				//رжϣʼٴ
//======ʱT0ʼڻȡʱ䣬ʱ򳬳෶Χ
	TH0 = 0;		
	TL0 = 0;
	ET0 = 1;
//======ʱT1ʼڻȡ1msʱж=====
	TH1 = 0xFC;		//öʱ1ĳֵ: 0xFC66Ӧʱʱ1ms
	TL1 = 0x66;
	ET1 = 1;			//ʹܶʱT1ж
	TR1 = 1;			//ʱT1
//======ʱT0T1ʼ=================	
	EX0 = 0;			//رⲿж
	IT0 = 0;			//ⲿж0õƽģʽ͵ƽ
	EA = 1;				//ʹж
}

/*
StartModule()
ܣģ飬 IO ࣬10us ĸߵƽź;
*/
void  StartModule()
{
	unsigned char i;
	Trig = 1;			                  //һģ
	for(i = 0;i < 5;i ++);					//ӳ10us;
	Trig = 0;
}
/*
Range_Display()
ܣʾ
˵ʾ- - - -
*/
 void Range_Display()
{
	cnt ++;		//ÿһΣֵһڲ
	DispBuf[7] = Tab[cnt / 100]; 
	DispBuf[6] = Tab[cnt / 10 % 10];
	DispBuf[5] = Tab[cnt % 10];
	//Χϰ̫Ƕ̫С޷յزʾ- - - -
	if((Range >= 4000) || Counter_overflag == 1)
	{	 
		Counter_overflag = 0;
		DispBuf[0] = 0x40;		  
		DispBuf[1] = 0x40;
		DispBuf[2] = 0x40;			  
		DispBuf[3] = 0x40;
	}
	//HC-SR04ָ꣬¹2cm450cmķΧڣƷͷ
	else		//ʾݵλ
	{
		DispBuf[0] = Tab[Range % 10];		  
		DispBuf[1] = Tab[Range / 10 % 10] + 0x80;
		DispBuf[2] = Tab[Range / 100 % 10];			  
		DispBuf[3] = Tab[Range / 1000];
	}
}
/*
Timer_Count()
ܣߵƽȼ㺯
עòѯģʽ
˵ģڵȴزʱ򣬾ʱжϴϣ»زʱʱ˳
Ľİ취Ƿֱ䣨ʱΣȡοգ
	TR1 = 0;		//ͣʱT1൱ڹرնʱжT1
  TR1 = 1;		//ʱT1൱ڴ򿪶ʱжT1
֮ʲôµأԭ
*/
unsigned int  Timer_Count()		
{
	
	TR0 = 1;		  //
	EX0 = 1;			//ⲿж
	while(!Echo_Over);	//ȴزEcho_OverΪ1յز򳬳෶Χ
	
	Echo_Over = 0;			//Echo_Over׼һβ
	//Ѿõ˳ӦֵڱEcho_timeڣEcho_time * 1.1usõӦʱ
	//軷¶26.5϶ȣEcho_timeֵмĳȣλף滻Ķֵʽ
	//ע⣺ö㣬Ϊף
	Range = 1234;     //λǺ

	return (unsigned int)Range;
}
void main()
{
	
	SysInit();		//ʱʼ
	
	DispBuf[7] = Tab[1];   		//8λʾ12345678
	DispBuf[6] = Tab[2];
	DispBuf[5] = Tab[3];
	DispBuf[4] = Tab[4];
	DispBuf[3] = Tab[5];
	DispBuf[2] = Tab[6];
	DispBuf[1] = Tab[7];
	DispBuf[0] = Tab[8];
	Delay(2000);					
	DispClear();				//ʾϵʾȫϨ
	DispBuf[7] = Tab[cnt / 100]; 
	DispBuf[6] = Tab[cnt / 10 % 10];
	DispBuf[5] = Tab[cnt % 10];
	while(1)
	{
		Echo = 1;			//IOڶ֮ǰ1
		TR1 = 0;			//رնʱT1ϳز
		ET1 = 0;			//رնʱT1жϣʱ̣ܶӰС
		StartModule();		//ģ
		while(!Echo);
		ET1 = 1;			//ʹܶʱT1ж
		TR1 = 1;			//ʱT1
    Range = Timer_Count();		//ߵƽȼ㺯
		Range_Display();					//ʾ
		Delay(200);							//ÿ0.2ȡһβʾһβݣӾ۲
	}

}

