/*
	main.c
	PWMֱٶȡ߼߼Ʋμ""̡
	ͨK1~K4PWMռձȣӶҵת١
*/

#include <reg52.h>


//I/Oӿ
sbit PWM_IN1 = P1^4; 	// ߵƽ1ˣת
sbit PWM_IN2 = P1^5; 	// ߵƽ1ǰת

sbit PWM_IN3 = P1^6; 	// ߵƽ1ҵǰת	
sbit PWM_IN4 = P1^7; 	// ߵƽ1ҵˣת

sbit PWM_EN1 = P1^2; 	// ߵƽ1ʹ 
sbit PWM_EN2 = P1^3; 	// ߵƽ1ʹҵ

sbit KEY1 = P3^4;		//尴K1'+'٣ӦİK1
sbit KEY2 = P3^5;		//尴K2'-'٣ӦİK2
sbit KEY3 = P3^6;		//尴K3'+'٣ӦİK3
sbit KEY4 = P3^7;		//尴K4'+'٣ӦİK4

//PWMҲǵֱٶȵȼ
#define SPEED_MAX		20

//PWMΪ0SPEED_MAX-1
unsigned char Speed_L;		//תٵڣPWMһSPEED_MAX*1msʱڣתʱ䣺Speed_L*1ms
unsigned char Speed_R;		//ҵתٵڣPWMһSPEED_MAX*1msʱڣҵתʱ䣺Speed_R*1ms

//ʾɶʱжϳԶɨ裩
unsigned char DispBuf[8];

//Сʾ·
sbit SS = P2^6;	   //ܶѡź
sbit CS = P2^7;	   //λѡź

code unsigned char Tab[] =		//ܵĶ루Σ
	{//0123456789AbCdEFݣʾַм㣬确-Ϊ0x40
		0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,
		0x7F,0x6F,0x77,0x7C,0x39,0x5E,0x79,0x71,
	};


unsigned char KeyScan();
void DispClear();
void DispInit();
void Delay(unsigned int t);
void SysInit();

void main()
{
	unsigned char k;

	SysInit();

	DispBuf[7] = 0x40;			//-
	DispBuf[6] = Tab[Speed_R / 10];
	DispBuf[5] = Tab[Speed_R % 10];
	DispBuf[4] = 0x40;			//-
	DispBuf[3] = 0x40;			//-
	DispBuf[2] = Tab[Speed_L / 10];
	DispBuf[1] = Tab[Speed_L % 10];
	DispBuf[0] = 0x40;			//-
	PWM_EN1 = 1;
	PWM_EN2 = 1;			//Ч

	while(1)
	{
		Delay(50);			//ʱ50ms
		k = KeyScan();		//ɨ
		if ( k != '\0' ) 
		{
			switch ( k )	//
			{
			case 'A':
				if ( Speed_L < SPEED_MAX-1 ) Speed_L ++;
				break;
			case 'B':
				if ( Speed_L > 0 ) Speed_L --;
				break;
			case 'C':
				if ( Speed_R < SPEED_MAX-1 ) Speed_R ++;
				break;
			case 'D':
				if ( Speed_R > 0 ) Speed_R --;
				break;
			default:
				break;
			}

			DispBuf[6] = Tab[Speed_L / 10];
			DispBuf[5] = Tab[Speed_L % 10];
			DispBuf[2] = Tab[Speed_R / 10];
			DispBuf[1] = Tab[Speed_R % 10];

			while( KeyScan() != '\0');		//ȴɿ
		}
	}
}


/*
KeyScan()
ܣɨ
أɨ赽ļֵ
*/
unsigned char KeyScan()
{
	unsigned char k;

	k = '\0';
	if ( KEY1 == 0 ) k = 'A';		//k1 '+'
	if ( KEY2 == 0 ) k = 'B';		//k2 '-'
	if ( KEY3 == 0 ) k = 'C';		//k3 '+'
	if ( KEY4 == 0 ) k = 'D';		//k4 '-'

	return k;
}

/*
DispClear()
ܣܵʾ
*/
void DispClear()
{
	unsigned char i;
	for ( i=0; i<8; i++ )
	{
		DispBuf[i] = 0x00;		//8λʾȫϨ
	}
}

/*
DispInit()
ܣɨʾʼ
*/
void DispInit()
{
	DispClear();	//ʼΪȫ
	EA = 0;
	TH1 = 0xFC;
	TL1 = 0x66;
	TR1 = 1;
	ET1 = 1;
	EA = 1;
}

/*
Delay()
ܣʱ
˵
	ƵΪ11.0592MHz
	ʱ = 1ms * t
*/
void Delay(unsigned int t)
{
	unsigned int us_ct;
	for (;t > 0;t --)		//ִдCPUʱ
		for (us_ct = 113;us_ct > 0;us_ct --);	
}


/*
SysInit()
ܣϵͳʼ
*/
void SysInit()
{
	TMOD = 0x11;		//T1Ϊ16λʱ

	PWM_EN1 = 0;
	PWM_EN2 = 0;		//Ч
	PWM_IN1 = 0;
	PWM_IN2 = 0; 		//ͣת
	PWM_IN3 = 0;
	PWM_IN4 = 0;		//ҵͣת

	Speed_L = 6;		//PWMֵʼת٣
	Speed_R = 6;		//ҵPWMֵ

	DispInit();

}

/*
T1_INT_SVC()
ܣʱT1жϷʱʱ1ms
*/
void T1INTSVC() interrupt 3
{
	code unsigned char com[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};	//ʾλĶ˿ڿֽ
	static unsigned char n = 0;	//n: ɨʾλ,0-7
	static unsigned char t = 0;

	TR1 = 0;
	TH1 = 0xFC;					//öʱֵ0xfc66Ӧ1msʱжʱ
	TL1 = 0x66;					//
	TR1 = 1;

	P0 = 0xFF;				//ͨ8λܵλƶˣCOMˣȫ
	CS = 1;
	CS = 0;

	P0 = DispBuf[n];	//ɨʾ
	SS = 1;
	SS = 0;

	P0 = ~com[n];			//ʾ
	CS = 1;
	CS = 0;

	n++;					 	//ָһλɨʾ
	n &= 0x07;
	
	t++;
	if ( t >= SPEED_MAX ) 
		t = 0;				//PWMΪSPEED_MAX*1ms = 20ms

	if ( t < Speed_L )		//PWMߵƽʱ䣺(Speed_L)*1ms
	{
    PWM_IN1 = 0;
		PWM_IN2 = 1; 		//ת
	}
	else					//PWM͵ƽʱ䣺SPEED_MAX-Speed_L*1ms
	{
    PWM_IN1 = 0;
		PWM_IN2 = 0; 		//ͣת
	}
	
	if ( t < Speed_R )		//PWMߵƽʱ䣺Speed_R*1ms
	{
		PWM_IN3 = 1;
		PWM_IN4 = 0;		//ҵת		
	}
	else					//PWM͵ƽʱ䣺SPEED_MAX-Speed_R*1ms
	{
		PWM_IN3 = 0;
		PWM_IN4 = 0;		//ҵͣת	
	}
}

