/*
	ܣSTC89C52 + AD&DA ģʵ顣
	1ģI2CʱADC/DAC
  2ͨʱADCDAC
	˵ʾͨ1ͨ3ĲֵͬʱDAC
	עADCPCF8591תͨ⣿עͺ͡
  ƣӿƼѧʵ20226
*/
#include<reg52.h>    //ƬĴͷļ

//-----------ģI2Cߵıر忪ʼ---------------
//I2CʱӵʱֵҪʵ޸ģȡֵ1255
//SCLźԼΪ(I2C_DELAY_VALUE*4+15)
#define I2C_DELAY_VALUE		10

//I2Cֹͣһοʼ֮ǰĵȴʱ䣬ȡֵ165535
//ȴʱԼΪ(I2C_STOP_WAIT_VALUE*8)
//ڶȡֵΪ1ɣĳЩ˵ϳʱǱ
#define I2C_STOP_WAIT_VALUE	1

//ģI2CߵŶ
sbit I2C_SCL = P2^1;		//I2C  ʱ
sbit I2C_SDA = P2^0;		//I2C  
sbit RST_DS = P2^4;   	//ϺԹصDS1302ʱоƬ

//PCF8591 ַ
#define  AddWr 0x90
//-----------ģI2Cߵıر---------------

//ʾɶʱжϳԶɨ裩
unsigned char DispBuf[8];

//Сʾ·ܽŶ
sbit SS = P2^6;	   //ܶѡź
sbit CS = P2^7;	   //λѡź

code unsigned char Tab[] =
	{//0123456789AbCdEFݣʾַм㣬确-Ϊ0x40
		0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,
		0x7F,0x6F,0x77,0x7C,0x39,0x5E,0x79,0x71
	};
	
//ʱںI2C_Delay()

/*
I2C_Delay()
ܣʱģI2Cר
*/
void I2C_Delay()
{
	unsigned char I2C_Delay_t;
	I2C_Delay_t = (I2C_DELAY_VALUE);
	while ( --I2C_Delay_t != 0 );
}


/*
I2C_Init()
ܣI2C߳ʼʹߴڿ״̬
˵main()ĿʼͨӦҪִһα
*/
void I2C_Init()
{
	I2C_SCL = 1;
	I2C_Delay();
	I2C_SDA = 1;
	I2C_Delay();
}


/*
I2C_Start()
ܣI2Cߵʼ״̬
˵
	SCLڸߵƽڼ䣬SDA½ʱI2C
	SDASCLʲôƽ״̬ȷʼ״̬
	Ҳظʼ״̬
	ִкI2Cߴæ״̬
*/
void I2C_Start()
{
	I2C_SDA = 1;
	I2C_Delay();
	I2C_SCL = 1;
	I2C_Delay();
	I2C_SDA = 0;
	I2C_Delay();
	I2C_SCL = 0;
	I2C_Delay();
}

/***********************************************************
I2C_Stop()
ܣI2Cߵֹͣ״̬
˵
	SCLڸߵƽڼ䣬SDAʱֹͣI2C
	SDASCLʲôƽ״̬ȷֹͣ״̬
	ִкI2Cߴڿ״̬
***********************************************************/
void I2C_Stop()
{
	unsigned int t = I2C_STOP_WAIT_VALUE;
	I2C_SDA = 0;
	I2C_Delay();
	I2C_SCL = 1;
	I2C_Delay();
	I2C_SDA = 1;
	I2C_Delay();
	while ( --t != 0 );		//һβStart֮ǰҪһʱ
}

/*
I2C_Write()
ܣI2Cд1ֽڵ

	datҪдϵ
*/
void I2C_Write(unsigned char dat)
{
	unsigned char t = 8;
	do
	{
		I2C_SDA = (bit)(dat & 0x80);
		dat <<= 1;
		I2C_SCL = 1;
		I2C_Delay();
		I2C_SCL = 0;
		I2C_Delay();
	} while ( --t != 0 );
}


/*
I2C_Read()
ܣӴӻȡ1ֽڵ
أȡһֽ
*/
unsigned char I2C_Read()
{
	unsigned char dat;
	unsigned char t = 8;
	I2C_SDA = 1;	//ڶȡ֮ǰҪSDA
	do
	{
		I2C_SCL = 1;
		I2C_Delay();
		dat <<= 1;
		if ( I2C_SDA ) dat |= 0x01;
		I2C_SCL = 0;
		I2C_Delay();
	} while ( --t != 0 );
	return dat;
}


/*
I2C_GetAck()
ܣȡӻӦλ
أ
	0ӻӦ
	1ӻӦ
˵
	ӻյÿֽڵݺҪӦλ
	ӻյ1ֽڵݺһҪӦλ
*/
bit I2C_GetAck()
{
	bit ack;
	I2C_SDA = 1;
	I2C_Delay();
	I2C_SCL = 1;
	I2C_Delay();
	ack = I2C_SDA;
	I2C_SCL = 0;
	I2C_Delay();
	return ack;
}


/*
I2C_PutAck()
ܣӦλӦλ

	ack=0Ӧλ
	ack=1Ӧλ
˵
	ڽÿһֽڵݺ󣬶ӦӦλ
	ڽһֽڵݺӦӦλ
*/
void I2C_PutAck(bit ack)
{
	I2C_SDA = ack;
	I2C_Delay();
	I2C_SCL = 1;
	I2C_Delay();
	I2C_SCL = 0;
	I2C_Delay();
}

/************************************************************
* 				: Pcf8591_DaConversion
* 			: PCF8591ģ
* 				: addrַchannelתͨvalueתֵ
* 				: 
******************* *****************************************/
bit Pcf8591_DaConversion(unsigned char addr,unsigned char channel,  unsigned char Val)
{
	I2C_Start();              //
	I2C_Write(addr);            //ַ
	if ( I2C_GetAck() )
	{
		I2C_Stop();
		return 1;
	}
   I2C_Write(0x40|channel);              //Ϳֽ
	if ( I2C_GetAck() )
	{
		I2C_Stop();
		return 1;
	}
  I2C_Write(Val);            //DACֵ  
	if ( I2C_GetAck() )
	{
		I2C_Stop();
		return 1;
	}
  I2C_Stop();               //
  return 0;
}

/************************************************************
* 			: Pcf8591_SendByte
* 		: дһ
* 			: addrַchannelתͨ
* 			: 
************************************************************/
bit PCF8591_SendByte(unsigned char addr,unsigned char channel)
{
  I2C_Start();              //
  I2C_Write(addr);            //ַ
	if ( I2C_GetAck() )
	{
		I2C_Stop();
		return 1;
	}
  I2C_Write(0x40|channel);              //Ϳֽ
	if ( I2C_GetAck() )
	{
		I2C_Stop();
		return 1;
	}
  I2C_Stop();               //
  return 0;
}

/************************************************************
*        	: PCF8591_RcvByte
*    	: ȡһתֵ
*           :
*           : dat
************************************************************/
unsigned char PCF8591_RcvByte(unsigned char addr)
{  
  unsigned char dat;

  I2C_Start();          //
  I2C_Write(addr+1);      //ַ
	if ( I2C_GetAck() )
	{
		I2C_Stop();
		return 1;
	}
	dat=I2C_Read();         //ȡ0

  I2C_PutAck(1);           //ͷӦź
  I2C_Stop();           //
  return(dat);
}

/*
T1INTSVC()
ܣʱT1жϷ
*/
void T1INTSVC() interrupt 3	//ʱ1жϺΪ3
{
	code unsigned char com[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};	//ʾλĶ˿ڿֽ
	static unsigned char n = 0;						//n: ɨʾλ,0-7

//================ܶʱɨʾ===============	
	TR1 = 0;
	TH1 = 0xFC;
	TL1 = 0x66;						//ԽFC660000ɨٶȣ۲⶯̬ɨ
	TR1 = 1;
	P0 = 0xFF;		//
	CS = 1;
	CS = 0;
	P0 = DispBuf[n];	//ɨʾ
	SS = 1;
	SS = 0;
	P0 = ~com[n];	//ʾ
	CS = 1;
	CS = 0;
	n++;					 	//ָһλɨʾ
	n &= 0x07;
//====================================================
}
/*
DispClear()
ܣܵʾ
*/
void DispClear()
{
	unsigned char i;
	for ( i=0; i<8; i++ )
	{
		DispBuf[i] = 0x00;	//iֵܵλںĳ۲0x00Թرʾ
	}
}
/*
SysInit()
ܣϵͳʼ
*/
void SysInit()
{

	DispClear();	//ʼΪȫ

	TMOD = 0x11;	//öʱT0Ϊ16λʱʱT1Ϊ16λʱ
	EA = 0;
	TH1 = 0xFC;		//öʱ1ĳֵ: 0xFC66Ӧʱʱ1ms
	TL1 = 0x66;
	ET1 = 1;		//ʹܶʱT1ж
	EA = 1;			//ʹж
	TR1 = 1;		//ʱT1
}
void Display(unsigned char dat1,unsigned char dat2)

{

	DispBuf[7] = Tab[dat1 / 100];   		//8λʾ12345678
	DispBuf[6] = Tab[dat1 /10 % 10];
	DispBuf[5] = Tab[dat1 % 10];

	DispBuf[2] = Tab[dat2 / 100];
	DispBuf[1] = Tab[dat2 /10 % 10];
	DispBuf[0] = Tab[dat2 % 10];
}
/*
Delayms()
ܣʱ
˵
	ƵΪ11.0592MHz
	ʱ = 1ms * t
*/
void Delayms(unsigned int t)
{
	unsigned int us_ct;
	for (;t > 0;t --)		//ִдCPUʱ
		for (us_ct = 113;us_ct > 0;us_ct --);	
}
/*------------------------------------------------
                    
------------------------------------------------*/
void main()
{  
	unsigned char light,voltage;//м
	unsigned char chl2,chl4;//м
	unsigned char AD_CHANNEL = 0;
	RST_DS = 0;											//		ʱDS1302
	SysInit();
	I2C_Init();
	//ʾ12345678ʾ
	DispBuf[7] = Tab[1];   		//8λʾ12345678
	DispBuf[6] = Tab[2];
	DispBuf[5] = Tab[3];
	DispBuf[4] = Tab[4];
	DispBuf[3] = Tab[5];
	DispBuf[2] = Tab[6];
	DispBuf[1] = Tab[7];
	DispBuf[0] = Tab[8];
	Delayms(2000);					//2s
	DispClear();				//ʾϵʾȫϨ	
	while(1)
	{

	/********AD-DA*************/  
	/*ADCPCF8591⣺
		A/DתڷһЧĶģʽַPCF8591豸ʼ
		A/DתӦʱĺԵÿADCȡһתĽ
		ͨתȡʱPCF8591_SendByte(AddWr,N)еNָҪһתͨ
		ŵPCF8591_RcvByte(AddWr);ȡĲһָʾͨǰһεġ
		粻ǶͨʱתֻһͨôNֻҪתͨˡ
	*/
		switch(AD_CHANNEL)
		{
			case 0: 
				PCF8591_SendByte(AddWr,1);
			  light = PCF8591_RcvByte(AddWr);  //ADC0 ģת1	 J8ϿɽԪ
			break;  
			
			case 1: 
				PCF8591_SendByte(AddWr,2);
			  chl2 =PCF8591_RcvByte(AddWr);  //ADC1  ģת2
			break;  
			
			case 2: 
				PCF8591_SendByte(AddWr,3);
				voltage =PCF8591_RcvByte(AddWr);  //ADC2	ģת3   ɵSW1
			break;  
			
			case 3: 
				PCF8591_SendByte(AddWr,0);
			  chl4 =PCF8591_RcvByte(AddWr);  //ADC3   ģת4	 ɵSW2
			break;
			
			case 4: 
				Pcf8591_DaConversion(AddWr,0, voltage); //DAC	  ģת
			break;			
		}		
		
		if(++AD_CHANNEL > 4) AD_CHANNEL = 0;
	  Display(light,voltage);
		Delayms(50);
   }
}