/*
	main.c
	ͨk1k2PWMռձȣPWMLEDȣPWM=16ms
	ȵȼ0-15, 16ʾܵ2λ
*/


#include <reg52.h>

//ʾɶʱжϳԶɨ裩
unsigned char DispBuf[8];

//Сʾ·ܽŶ
sbit SS = P2^6;	   //ܶѡź
sbit CS = P2^7;	   //λѡź
//Сܰ·ܽŶ
sbit KEY1 = P3^4;		//尴1'+'ӦİK1
sbit KEY2 = P3^5;		//尴2'-'ӦİK2
code unsigned char Tab[] =
	{//0123456789AbCdEFݣʾַм㣬确-Ϊ0x40
		0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,
		0x7F,0x6F,0x77,0x7C,0x39,0x5E,0x79,0x71
	};
	
//I/Oӿ
sbit PWM = P1^0;		//PWMLED
	
//PWMҲǵLEDȵȼ
#define PWM_MAX		16
//PWMΪ0PWM_MAX-1
unsigned char PwmValue;
	
/*
T1INTSVC()
ܣʱT1жϷ
*/
void T1INTSVC() interrupt 3	//ʱ1жϺΪ3
{
	code unsigned char com[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};	//ʾλĶ˿ڿֽ
	static unsigned char n = 0;						//n: ɨʾλ,0-7
	static unsigned char t = 0;

//================ܶʱɨʾ===============	
	TR1 = 0;
	TH1 = 0xFC;
	TL1 = 0x66;						//ԽFC660000ɨٶȣ۲⶯̬ɨ
	TR1 = 1;
	P0 = 0xFF;		//
	CS = 1;
	CS = 0;
	P0 = DispBuf[n];	//ɨʾ
	SS = 1;
	SS = 0;
	P0 = ~com[n];	//ʾ
	CS = 1;
	CS = 0;
	n++;					 	//ָһλɨʾ
	n &= 0x07;
//====================================================
//==========öʱжʵ====================
	t++;			//עtĶ巽ʽ
	if ( t >= PWM_MAX ) t = 0;	//PWMΪ16ms
	if ( t < PwmValue )
	{
		PWM = 0;	//PWM͵ƽʱ(LED)
	}
	else
	{
		PWM = 1;	//PWMߵƽʱ(LED)
	}

//====================================================
}


/*
DispClear()
ܣܵʾ
*/
void DispClear()
{
	unsigned char i;
	for ( i=0; i<8; i++ )
	{
		DispBuf[i] = 0x00;	//iֵܵλںĳ۲0x00Թرʾ
	}
}

/*
Delay()
ܣʱ
˵
	ƵΪ11.0592MHz
	ʱ = 1ms * t
*/
void Delay(unsigned int t)
{
	unsigned int us_ct;
	for (;t > 0;t --)		//ִдCPUʱ
		for (us_ct = 113;us_ct > 0;us_ct --);	
}

/*
KeyScan()
ܣɨ
أɨ赽ļֵ
*/
unsigned char KeyScan()
{
	unsigned char k = '\0';

	if ( KEY1 == 0 ) k = '+';
	if ( KEY2 == 0 ) k = '-';

	return k;
}

/*
SysInit()
ܣϵͳʼ
*/
void SysInit()
{

	DispClear();	//ʼΪȫ

	TMOD = 0x11;	//öʱT0Ϊ16λʱʱT1Ϊ16λʱ
	EA = 0;
	TH1 = 0xFC;		//öʱ1ĳֵ: 0xFC66Ӧʱʱ1ms
	TL1 = 0x66;
	ET1 = 1;		//ʹܶʱT1ж
	EA = 1;			//ʹж
	TR1 = 1;		//ʱT1
}


void main()
{

	unsigned char k;					//ֵ
	unsigned char cnt = 18;		//ֵĳʼֵ
	
	SysInit();								//ϵͳʼ
	PwmValue = PWM_MAX / 2;		//PWMֵмȼȣ
	PWM = 0;
	
	DispBuf[7] = Tab[1];   		//8λʾ12345678
	DispBuf[6] = Tab[2];
	DispBuf[5] = Tab[3];
	DispBuf[4] = Tab[4];
	DispBuf[3] = Tab[5];
	DispBuf[2] = Tab[6];
	DispBuf[1] = Tab[7];
	DispBuf[0] = Tab[8];
	Delay(2000);					//1s

	DispClear();				//ʾϵʾȫϨ
	DispBuf[1] = Tab[PwmValue / 10];
	DispBuf[0] = Tab[PwmValue % 10];

	while(1)
	{
		Delay(20);
		k = KeyScan();	//ɨ
		if ( k != '\0')
		{
			if ( k == '+') 
			{
				if ( PwmValue < PWM_MAX-1 ) PwmValue++;
			}
			if ( k == '-')
			{
				if ( PwmValue > 0 ) PwmValue--;
			}
			
			DispBuf[1] = Tab[PwmValue / 10];
			DispBuf[0] = Tab[PwmValue % 10];

			while( KeyScan() != '\0');			//ȴɿ
		}
	}
}

